// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlFileChooserEntry")]
    pub struct FileChooserEntry(Object<ffi::DzlFileChooserEntry, ffi::DzlFileChooserEntryClass>) @extends gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_file_chooser_entry_get_type(),
    }
}

impl FileChooserEntry {
    pub const NONE: Option<&'static FileChooserEntry> = None;

    #[doc(alias = "dzl_file_chooser_entry_new")]
    pub fn new(title: &str, action: gtk::FileChooserAction) -> FileChooserEntry {
        assert_initialized_main_thread!();
        unsafe {
            gtk::Widget::from_glib_none(ffi::dzl_file_chooser_entry_new(
                title.to_glib_none().0,
                action.into_glib(),
            ))
            .unsafe_cast()
        }
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::FileChooserEntry>> Sealed for T {}
}

pub trait FileChooserEntryExt: IsA<FileChooserEntry> + sealed::Sealed + 'static {
    #[cfg(feature = "v3_32")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_32")))]
    #[doc(alias = "dzl_file_chooser_entry_get_entry")]
    #[doc(alias = "get_entry")]
    fn entry(&self) -> Option<gtk::Entry> {
        unsafe {
            from_glib_none(ffi::dzl_file_chooser_entry_get_entry(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_file_chooser_entry_get_file")]
    #[doc(alias = "get_file")]
    fn file(&self) -> Option<gio::File> {
        unsafe {
            from_glib_full(ffi::dzl_file_chooser_entry_get_file(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_file_chooser_entry_set_file")]
    fn set_file(&self, file: &impl IsA<gio::File>) {
        unsafe {
            ffi::dzl_file_chooser_entry_set_file(
                self.as_ref().to_glib_none().0,
                file.as_ref().to_glib_none().0,
            );
        }
    }

    fn action(&self) -> gtk::FileChooserAction {
        ObjectExt::property(self.as_ref(), "action")
    }

    fn set_action(&self, action: gtk::FileChooserAction) {
        ObjectExt::set_property(self.as_ref(), "action", action)
    }

    #[doc(alias = "create-folders")]
    fn creates_folders(&self) -> bool {
        ObjectExt::property(self.as_ref(), "create-folders")
    }

    #[doc(alias = "create-folders")]
    fn set_create_folders(&self, create_folders: bool) {
        ObjectExt::set_property(self.as_ref(), "create-folders", create_folders)
    }

    #[doc(alias = "do-overwrite-confirmation")]
    fn does_overwrite_confirmation(&self) -> bool {
        ObjectExt::property(self.as_ref(), "do-overwrite-confirmation")
    }

    #[doc(alias = "do-overwrite-confirmation")]
    fn set_do_overwrite_confirmation(&self, do_overwrite_confirmation: bool) {
        ObjectExt::set_property(
            self.as_ref(),
            "do-overwrite-confirmation",
            do_overwrite_confirmation,
        )
    }

    fn filter(&self) -> Option<gtk::FileFilter> {
        ObjectExt::property(self.as_ref(), "filter")
    }

    fn set_filter(&self, filter: Option<&gtk::FileFilter>) {
        ObjectExt::set_property(self.as_ref(), "filter", filter)
    }

    #[doc(alias = "local-only")]
    fn is_local_only(&self) -> bool {
        ObjectExt::property(self.as_ref(), "local-only")
    }

    #[doc(alias = "local-only")]
    fn set_local_only(&self, local_only: bool) {
        ObjectExt::set_property(self.as_ref(), "local-only", local_only)
    }

    #[doc(alias = "max-width-chars")]
    fn max_width_chars(&self) -> i32 {
        ObjectExt::property(self.as_ref(), "max-width-chars")
    }

    #[doc(alias = "max-width-chars")]
    fn set_max_width_chars(&self, max_width_chars: i32) {
        ObjectExt::set_property(self.as_ref(), "max-width-chars", max_width_chars)
    }

    #[doc(alias = "show-hidden")]
    fn shows_hidden(&self) -> bool {
        ObjectExt::property(self.as_ref(), "show-hidden")
    }

    #[doc(alias = "show-hidden")]
    fn set_show_hidden(&self, show_hidden: bool) {
        ObjectExt::set_property(self.as_ref(), "show-hidden", show_hidden)
    }

    fn title(&self) -> Option<glib::GString> {
        ObjectExt::property(self.as_ref(), "title")
    }

    fn set_title(&self, title: Option<&str>) {
        ObjectExt::set_property(self.as_ref(), "title", title)
    }

    #[doc(alias = "action")]
    fn connect_action_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_action_trampoline<
            P: IsA<FileChooserEntry>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlFileChooserEntry,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(FileChooserEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::action\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_action_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "create-folders")]
    fn connect_create_folders_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_create_folders_trampoline<
            P: IsA<FileChooserEntry>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlFileChooserEntry,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(FileChooserEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::create-folders\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_create_folders_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "do-overwrite-confirmation")]
    fn connect_do_overwrite_confirmation_notify<F: Fn(&Self) + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId {
        unsafe extern "C" fn notify_do_overwrite_confirmation_trampoline<
            P: IsA<FileChooserEntry>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlFileChooserEntry,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(FileChooserEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::do-overwrite-confirmation\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_do_overwrite_confirmation_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "file")]
    fn connect_file_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_file_trampoline<
            P: IsA<FileChooserEntry>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlFileChooserEntry,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(FileChooserEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::file\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_file_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "filter")]
    fn connect_filter_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_filter_trampoline<
            P: IsA<FileChooserEntry>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlFileChooserEntry,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(FileChooserEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::filter\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_filter_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "local-only")]
    fn connect_local_only_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_local_only_trampoline<
            P: IsA<FileChooserEntry>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlFileChooserEntry,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(FileChooserEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::local-only\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_local_only_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "max-width-chars")]
    fn connect_max_width_chars_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_max_width_chars_trampoline<
            P: IsA<FileChooserEntry>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlFileChooserEntry,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(FileChooserEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::max-width-chars\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_max_width_chars_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "show-hidden")]
    fn connect_show_hidden_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_show_hidden_trampoline<
            P: IsA<FileChooserEntry>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlFileChooserEntry,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(FileChooserEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::show-hidden\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_show_hidden_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "title")]
    fn connect_title_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_title_trampoline<
            P: IsA<FileChooserEntry>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlFileChooserEntry,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(FileChooserEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::title\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_title_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<FileChooserEntry>> FileChooserEntryExt for O {}

impl fmt::Display for FileChooserEntry {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("FileChooserEntry")
    }
}
